from dispatch.dispatcher import *

import unittest
def x(a):
	return a
class DispatcherTests(unittest.TestCase):
	"""Test suite for dispatcher (barely started)"""
	def testExact (self):
		a = object()
		signal = 'this'
		connect( x, signal, a )
		expected = [(x,a)]
		result = send('this',a, a=a)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		disconnect( x, signal, a )
		assert len(list(getAllReceivers(a,signal))) == 0
	def testAnonymousSend(self):
		a = object()
		signal = 'this'
		connect( x, signal )
		expected = [(x,a)]
		result = send('this',None, a=a)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		disconnect( x, signal )
		assert len(list(getAllReceivers(None,signal))) == 0
	def testAnyRegistration(self):
		a = object()
		signal = 'this'
		connect( x, signal, Any )
		expected = [(x,a)]
		result = send('this',object(), a=a)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		disconnect( x, signal, Any )
		expected = []
		result = send('this',object(), a=a)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		assert len(list(getAllReceivers(Any,signal))) == 0
		
	def testAnyRegistration2(self):
		a = object()
		signal = 'this'
		connect( x, Any, a )
		expected = [(x,a)]
		result = send('this',a, a=a)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		disconnect( x, Any, a )
		assert len(list(getAllReceivers(a,Any))) == 0
	def testGarbageCollected(self):
		class x:
			def a( self, a ):
				return a
		a = x()
		b = object()
		signal = 'this'
		connect( a.a, signal, b )
		expected = []
		del a
		result = send('this',b, a=b)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		assert len(list(getAllReceivers(b,signal))) == 0, """Remaining handlers: %s"""%(getAllReceivers(b,signal),)
	def testGarbageCollectedObj(self):
		class x:
			def __call__( self, a ):
				return a
		a = x()
		b = object()
		signal = 'this'
		connect( a, signal, b )
		expected = []
		del a
		result = send('this',b, a=b)
		assert result == expected,"""Send didn't return expected result:\n\texpected:%s\n\tgot:%s"""% (expected, result)
		assert len(list(getAllReceivers(b,signal))) == 0, """Remaining handlers: %s"""%(getAllReceivers(b,signal),)
def getSuite():
	return unittest.makeSuite(DispatcherTests,'test')
		
if __name__ == "__main__":
	unittest.main ()
